% clc; clear;

%%% Constants %%%
E = 8e9;
C = 0;
A = (75e-6)*(5.8e-2);
L = 0.55;
md = 0.5;
Kd = 1080;
Bd = 15; %1/2*sqrt(md)*sqrt(Kd)*10;
g = 9.82;
T_ref = 25;
Fx = 22;
d_ref = (2*T_ref-Fx)/Kd;
LN = L - 2*d_ref;
V1 = 0.1;
Bm = 3e-3;
J = 0.309e-2;
R = 0.013; %13
N = 10.75;
%e = E*A/L;
%c = C*A/L;
%v = V1/L;
core_r = 0.013; % m
paper_thickness = 7.5e-5; % m
% t_d = 1/1000;
Ts = 1/1000;

ic = [0 (md*g/2) 0 0];

Aa = [-Bm/J        -R/(N*J)  0          0;
       E*A/LN*R/N  -V1/LN   -2*E*A/LN   0;
       0            2/md    -Bd/md     -Kd/md;
       0            0        1          0];

Bb = [1/J  0       0;
      0   -E*A/LN  0
      0    0       1/md
      0    0       0];

Ccc = [0 0 0 1 0];
Aaa = [Aa zeros(size(Aa,1),1); Ccc];
Bbb = [Bb(:,1); 0];


Rmat = 1/0.1^2;
Qmat = diag([1/(1000/60*2*pi)^2 1/50^2 1/0.1^2 1/0.1^2 1/(1e-3)^2]); % omega tension dancer_vel dancer_position
% K = lqr(Aaa, Bbb, Qmat, Rmat);

% %%% Observer %%%
Cobs = [1 0 0 0
        0 0 0 1];
Qobs=diag([20 2 0.1 1e-3]);
Robs=diag([0.1e-3 0.1e-3]);
Gobs=eye(4);
Lobs=lqe(Aa,Gobs,Cobs,Qobs,Robs);

%%% Intial Conditions %%%
%ic = [15.3719 22.4448 0 0.0400]; % omega tension v_d d
% ic = [0 0 (md*g/2) 0 0];
% 
% 
%%% State Space Model %%%
% Aa = [-1/t_d  0            0        0          0
%        1/J   -Bm/J        -R/(N*J)  0          0
%        0      E*A/LN*R/N  -V1/LN   -2*E*A/LN   0
%        0      0            2/md    -Bd/md     -Kd/md
%        0      0            0        1          0];
% 
% Bb = [1/t_d  0       0
%       0      0       0
%       0     -E*A/LN  0
%       0      0       1/md
%       0      0       0];
% 
% % Cc = [1 0 0 0;
% %     0 0 0 1];
% Cc = [0 0 0 0 1];
% 
% Dd = 0;
% 
% sys = ss(Aa,Bb,Cc,Dd);
% 
% 
% %%% Integrator %%%
% Ccc = [0 0 0 0 1 0];
% Aaa = [Aa zeros(size(Aa,1),1); Ccc];
% Bbb = [Bb(:,1); 0];
% 
% 
% Rmat = 1/0.1^2;
% Qmat = diag([1/0.1^2 1/(10/60*2*pi)^2 1/1^2 1/0.01^2 1/0.01^2 1/(1e-3)^2]); % omega tension dancer_vel dancer_position
% K = lqr(Aaa, Bbb, Qmat, Rmat);
% 
% 
% %%% Observer %%%
% Cobs = [0 1 0 0 0
%         0 0 0 0 1];
% Qobs=diag([1e-3 20 2 0.1 1e-3]);
% Robs=diag([0.1e-3 0.1e-3]);
% Gobs=eye(5);
% Lobs=lqe(Aa,Gobs,Cobs,Qobs,Robs);
% 
% %%%%%%%%%%%%%%%%%%%%%%%
