function [Kinit,K,Rs,V1s,gammas] = gain_creator()

Rs = 13e-3:5e-3:70e-3;
V1s = 0.1:0.05:0.5;
gammas = 1:5:100;

nR = length(Rs);
nV1 = length(V1s);
ngamma = length(gammas);

K = zeros(nR*nV1*ngamma,5);
for gammai = 1:ngamma
    for V1i = 1:nV1
        for Ri = 1:nR
            K(nR*nV1*(gammai-1) + nR*(V1i-1)+Ri,:) = single_lqr(Rs(Ri),V1s(V1i),gammas(gammai));
        end
    end
end

Kinit = single_lqr(13e-3,0.1,1);

function K = single_lqr(R,V1,gamma)

%%% Constants %%%
E = 8e9;
C = 0;
A = (75e-6)*(5.8e-2);
L = 0.55;
md = 0.5;
Kd = 1080;
Bd = 15; %1/2*sqrt(md)*sqrt(Kd)*10;
g = 9.82;
T_ref = 25;
Fx = 22;
d_ref = (2*T_ref-Fx)/Kd;
LN = L - 2*d_ref;
Bm = 5e-4;
J = 0.309e-2;
N = 10.75;
core_r = 0.013; % m
paper_thickness = 7.5e-5; % m

Aa = [-Bm/J        -R/(N*J)  0          0;
       E*A/LN*R/N  -V1/LN   -2*E*A/LN   0;
       0            2/md    -Bd/md     -Kd/md;
       0            0        1          0];

Bb = [1/J  0       0;
      0   -E*A/LN  0
      0    0       1/md
      0    0       0];

Ccc = [0 0 0 1 0];
Aaa = [Aa zeros(size(Aa,1),1); Ccc];
Bbb = [Bb(:,1); 0];


Rmat = 1/0.1^2;
Qmat = gamma*diag([1/(1000/60*2*pi)^2 1/100^2 1/1^2 1/0.1^2 1/(1e-3)^2]); % omega tension dancer_vel dancer_position
K = lqr(Aaa, Bbb, Qmat, Rmat);